package xyz.lychee.lagfixer.libs.adventure.text;

import java.util.List;
import java.util.Objects;
import java.util.stream.Stream;
import xyz.lychee.lagfixer.libs.adventure.text.format.Style;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.Nullable;
import xyz.lychee.lagfixer.libs.annotations.ApiStatus.ScheduledForRemoval;
import xyz.lychee.lagfixer.libs.annotations.Debug.Renderer;
import xyz.lychee.lagfixer.libs.examination.ExaminableProperty;
import xyz.lychee.lagfixer.libs.examination.string.StringExaminer;

/** @deprecated */
@Deprecated
@ScheduledForRemoval(
   inVersion = "5.0.0"
)
@Renderer(
   text = "this.debuggerString()",
   childrenArray = "this.children().toArray()",
   hasChildren = "!this.children().isEmpty()"
)
public abstract class AbstractComponent implements Component {
   protected final List<Component> children;
   protected final Style style;

   protected AbstractComponent(final @NotNull List<? extends ComponentLike> children, final @NotNull Style style) {
      this.children = ComponentLike.asComponents(children, IS_NOT_EMPTY);
      this.style = style;
   }

   public final @NotNull List<Component> children() {
      return this.children;
   }

   public final @NotNull Style style() {
      return this.style;
   }

   public boolean equals(final @Nullable Object other) {
      if (this == other) {
         return true;
      } else if (!(other instanceof AbstractComponent)) {
         return false;
      } else {
         AbstractComponent that = (AbstractComponent)other;
         return Objects.equals(this.children, that.children) && Objects.equals(this.style, that.style);
      }
   }

   public int hashCode() {
      int result = this.children.hashCode();
      result = 31 * result + this.style.hashCode();
      return result;
   }

   public abstract String toString();

   private String debuggerString() {
      Stream<? extends ExaminableProperty> examinablePropertiesWithoutChildren = this.examinableProperties().filter((property) -> {
         return !property.name().equals("children");
      });
      return (String)StringExaminer.simpleEscaping().examine(this.examinableName(), examinablePropertiesWithoutChildren);
   }
}
